;***********************************************  *********************************************
TurnOffTimeoutCh1:
        sbrc    rBit1, bTurnOffStartedCh1        ;   ,
        rjmp    TurnOffStartedCh1               ;    .

        lds     Temp, mOffTimeoutSecondCh1
        dec     Temp
        sts     mOffTimeoutSecondCh1, Temp
        brne    ExtendedExitOffTimeoutCh1       ;
        ldi     Temp, 100
;ldi Temp, 1 ;      
        sts     mOffTimeoutSecondCh1, Temp
        lds     Temp, mOffTimeoutMinuteCh1
        dec     Temp
        sts     mOffTimeoutMinuteCh1, Temp
        brne    ExtendedExitOffTimeoutCh1       ;
        ldi     Temp, 60
        sts     mOffTimeoutMinuteCh1, Temp
        lds     Temp, mOffTimeoutHourCh1
        dec     Temp
        sts     mOffTimeoutHourCh1, Temp
        brne    ExtendedExitOffTimeoutCh1       ;
        ldi     Temp, 60
        sts     mOffTimeoutHourCh1, Temp
        lds     Temp, meOffTimeoutHourCh1
        dec     Temp
        sts     meOffTimeoutHourCh1, Temp
        brne    ExtendedExitOffTimeoutCh1       ; ,  

        sbr     rBit1, 1<<bTurnOffStartedCh1    ;     ,    .
        cbr     reSystemBits, 1<<ebPowerStateCh1;          .

        sbrc    reUserBits1, ebAutoOffModeCh1   ;       .
        rjmp    AutoOffMode2Ch1

        lds     Temp, meOffTimeMode1Ch1         ;  -      ,
        sts     mOffSharedCellCh1, Temp         ;   meOffTimeMode1Ch1.
        rjmp    ExitOffTimeoutCh1

AutoOffMode2Ch1:                                ;  -      (   17).
        lds     Temp, meBrightDecrPercentCh1    ;  ,  ,     .
        subi    Temp, 10                        ;        0,   10,   .
        ldi	ZH, HIGH(2*PercentageTable)
        ldi	ZL, LOW(2*PercentageTable)
        add	ZL, Temp
        ldi	Temp, 0		
        adc	ZH, Temp
        lpm	Temp, Z                         ;    .
        mul     rBrightnessCh1, Temp            ;     ,
        mov     rSoftOffBrightCh1, R1           ;   256.
        sbrc    R0, 7                           ;   
        inc     rSoftOffBrightCh1               ;   .
        sbr	rBit1, 1<<bSoftTurnCh1          ;   
        cbr	rBit1, 1<<bIsChannel1On         ; ,    rSoftOffBrightCh1.
        lds     Temp, meOffTimeMode2Ch1         ;   mOffSharedCellCh1      ,
        sts     mOffSharedCellCh1, Temp         ;          .
ExtendedExitOffTimeoutCh1:
        rjmp    ExitOffTimeoutCh1


TurnOffStartedCh1:
        sbrc    reUserBits1, ebAutoOffModeCh1   ;  
        rjmp    TurnOffStartedMode2Ch1          ;      .

        lds     Temp, mOffSharedCellCh1         ; .
        dec     Temp                            ; 10    ,
        sts     mOffSharedCellCh1, Temp         ;  eOffTimeMode1Ch1.
        brne    ExitOffTimeoutCh1               ;   
        lds     Temp, meOffTimeMode1Ch1         ;   
        sts     mOffSharedCellCh1, Temp
        mov	Temp, rBrightnessCh1
        cpi     Temp, 0
        breq    TurnOffCompletedCh1
        dec     rBrightnessCh1                  ;  .      
        rjmp    ExitOffTimeoutCh1               ;  .

TurnOffStartedMode2Ch1:                         ; .            .
        lds     Temp, mOffTimeoutSecondCh1
        dec     Temp
        sts     mOffTimeoutSecondCh1, Temp
        brne    ExitOffTimeoutCh1               ;
        ldi     Temp, 100
;ldi Temp, 1 ;      
        sts     mOffTimeoutSecondCh1, Temp
        lds     Temp, mOffTimeoutMinuteCh1
        dec     Temp
        sts     mOffTimeoutMinuteCh1, Temp
        brne    ExitOffTimeoutCh1               ;
        ldi     Temp, 60
        sts     mOffTimeoutMinuteCh1, Temp
        lds     Temp, mOffSharedCellCh1
        dec     Temp
        sts     mOffSharedCellCh1, Temp
        brne    ExitOffTimeoutCh1

TurnOffCompletedCh1:
        cbr     rBit1, (1<<bTurnOffStartedCh1)+(1<<bIsChannel1On);       ,
        sbr     rBit1, 1<<bSoftTurnCh1          ; .

ExitOffTimeoutCh1:
        ret

;***********************************************  *********************************************
TurnOffTimeoutCh2:
        sbrc    rBit1, bTurnOffStartedCh2
        rjmp    TurnOffStartedCh2

        lds     Temp, mOffTimeoutSecondCh2
        dec     Temp
        sts     mOffTimeoutSecondCh2, Temp
        brne    ExtendedExitOffTimeoutCh2
        ldi     Temp, 100
;ldi Temp, 1 ;    
        sts     mOffTimeoutSecondCh2, Temp
        lds     Temp, mOffTimeoutMinuteCh2
        dec     Temp
        sts     mOffTimeoutMinuteCh2, Temp
        brne    ExtendedExitOffTimeoutCh2
        ldi     Temp, 60
        sts     mOffTimeoutMinuteCh2, Temp
        lds     Temp, mOffTimeoutHourCh2
        dec     Temp
        sts     mOffTimeoutHourCh2, Temp
        brne    ExtendedExitOffTimeoutCh2
        ldi     Temp, 60
        sts     mOffTimeoutHourCh2, Temp
        lds     Temp, meOffTimeoutHourCh2
        dec     Temp
        sts     meOffTimeoutHourCh2, Temp
        brne    ExtendedExitOffTimeoutCh2

        sbr     rBit1, 1<<bTurnOffStartedCh2
        cbr     reSystemBits, 1<<ebPowerStateCh2

        sbrc    reUserBits1, ebAutoOffModeCh2
        rjmp    AutoOffMode2Ch2

        lds     Temp, meOffTimeMode1Ch2
        sts     mOffSharedCellCh2, Temp
        rjmp    ExitOffTimeoutCh2

AutoOffMode2Ch2:
        lds     Temp, meBrightDecrPercentCh2
        subi    Temp, 10
        ldi	ZH, HIGH(2*PercentageTable)
        ldi	ZL, LOW(2*PercentageTable)
        add	ZL, Temp
        ldi	Temp, 0		
        adc	ZH, Temp
        lpm	Temp, Z
        mul     rBrightnessCh2, Temp
        mov     rSoftOffBrightCh2, R1
        sbrc    R0, 7
        inc     rSoftOffBrightCh2
        sbr	rBit1, 1<<bSoftTurnCh2
        cbr	rBit1, 1<<bIsChannel2On
        lds     Temp, meOffTimeMode2Ch2
        sts     mOffSharedCellCh2, Temp
ExtendedExitOffTimeoutCh2:
        rjmp    ExitOffTimeoutCh2


TurnOffStartedCh2:
        sbrc    reUserBits1, ebAutoOffModeCh2
        rjmp    TurnOffStartedMode2Ch2

        lds     Temp, mOffSharedCellCh2
        dec     Temp
        sts     mOffSharedCellCh2, Temp
        brne    ExitOffTimeoutCh2
        lds     Temp, meOffTimeMode1Ch2
        sts     mOffSharedCellCh2, Temp
        mov	Temp, rBrightnessCh2
        cpi     Temp, 0
        breq    TurnOffCompletedCh2
        dec     rBrightnessCh2
        rjmp    ExitOffTimeoutCh2

TurnOffStartedMode2Ch2:
        lds     Temp, mOffTimeoutSecondCh2
        dec     Temp
        sts     mOffTimeoutSecondCh2, Temp
        brne    ExitOffTimeoutCh2
        ldi     Temp, 100
;ldi Temp, 1 ;    
        sts     mOffTimeoutSecondCh2, Temp
        lds     Temp, mOffTimeoutMinuteCh2
        dec     Temp
        sts     mOffTimeoutMinuteCh2, Temp
        brne    ExitOffTimeoutCh2
        ldi     Temp, 60
        sts     mOffTimeoutMinuteCh2, Temp
        lds     Temp, mOffSharedCellCh2
        dec     Temp
        sts     mOffSharedCellCh2, Temp
        brne    ExitOffTimeoutCh2

TurnOffCompletedCh2:
        cbr     rBit1, (1<<bTurnOffStartedCh2)+(1<<bIsChannel2On)
        sbr     rBit1, 1<<bSoftTurnCh2

ExitOffTimeoutCh2:
        ret

;****************************************   ***************************************************

ResetAutoOffTimerCh1:
        ldi     Temp, 100                       ;      10.,    ,
        sts     mOffTimeoutSecondCh1, Temp      ;  ,      1000/10=100.
        ldi     Temp, 60
        sts     mOffTimeoutMinuteCh1, Temp
;ldi Temp, 1    ;        1
        sts     mOffTimeoutHourCh1, Temp
        lds     Temp, meOffTimeoutHoursCh1
        sts     meOffTimeoutHourCh1, Temp
        ret

ResetAutoOffTimerCh2:
        ldi     Temp, 100
        sts     mOffTimeoutSecondCh2, Temp
        ldi     Temp, 60
        sts     mOffTimeoutMinuteCh2, Temp
;ldi Temp, 1    ;        2
        sts     mOffTimeoutHourCh2, Temp
        lds     Temp, meOffTimeoutHoursCh2
        sts     meOffTimeoutHourCh2, Temp
        ret

;****************************************        ******************

OwnersAtHomeTimerTrigger:
        ldi     Temp, 1
        sts     mOwnersAtHomeSeconds, Temp
        sts     mOwnersAtHomeMinutes, Temp
        sts     mOwnersAtHomeSharedCell, Temp
        ret

