RESET:	
        .include "ResetCause.asm"; ( )  .
        cli                     ;  .

  ;    .
	in	Temp, WDTCR
	sbr	Temp, (1<<WDE)+(1<<WDP2)+(1<<WDP1)+(1<<WDP0);    -
        wdr	
	out	WDTCR, Temp	; -   2 .

  ;  .
	
  ; .
	ldi	Temp, HIGH(RAMEND)
	out	SPH, Temp
	ldi	Temp, LOW(RAMEND)
	out	SPL, Temp

  ;  JTAG.
	in	Temp, MCUCSR
	sbr	Temp, 1<<JTD
	out	MCUCSR, Temp	;  JTAG   
 	out	MCUCSR, Temp	;(          4- ).
 	
  ;  /.
        ldi	Temp, 0b01111100;   -  ,   -  ,
        out	PORTA, Temp	; -   .
	ldi	Temp, 0b00000011;   -  ,
	out	DDRA, Temp	; - .
	ldi	Temp, 0b11111111;     .
	out	PORTB, Temp	
        ldi	Temp, 0b00000000
        out	DDRB, Temp	
	ldi	Temp, 0b11111111
	out	PORTC, Temp	
	ldi	Temp, 0b00000000
	out	DDRC, Temp	
        ldi	Temp, 0b11111111
	out	PORTD, Temp
        ldi	Temp, 0b00000000
	out	DDRD, Temp	

  ;  .

  ;  . (   ,    ).
      	sbi	ACSR, ACD	;   (  ).
	;clr	Temp
	;sbr	Temp, (0<<ACIS1)+(0<<ACIS0);  ;  
	;out	ACSR, Temp	;   ACSR  (      ).
	;sbi	ACSR, ACIE	;   .
	
  ; - .
        clr     Temp
        sbr     Temp, (0<<REFS1)+(1<<REFS0);    - AVCC.
        sbr     Temp, 1<<ADLAR  ;   - (  ).
        sbr     Temp, (0<<MUX4)+(0<<MUX3)+(1<<MUX2)+(1<<MUX1)+(1<<MUX0);  - ADC7(PA7).
        out     ADMUX, Temp
        in      Temp, SFIOR
        cbr     Temp, (1<<ADTS2)+(1<<ADTS1)+(1<<ADTS0)
        ori     Temp, (0<<ADTS2)+(0<<ADTS1)+(0<<ADTS0);   - Free Running Mode.
        out     SFIOR, Temp
        clr     Temp
        sbr     Temp, 1<<ADATE  ; .
        ;sbr     Temp, 1<<ADIE   ; .
        ;sbr     Temp, (1<<ADPS2)+(0<<ADPS1)+(1<<ADPS0); .   500 (    , ..  ).
        sbr     Temp, 1<<ADEN   ; .
        sbr     Temp, 1<<ADSC   ;       .
        out     ADCSRA, Temp

   ;   EEPROM.
        cbi     EECR, EEWE
        clr     Temp
        out     EEARH, Temp
        out     EEARL, Temp

  ; .	
    ; 0

    ; 1
        ;ldi	Temp, 0
	;ldi     Tmp, 0
        ;out	TCNT1H, Temp
	;out	TCNT1L, Tmp
        ;ldi	Temp, 0
        ;ldi     Tmp, 0
        ;out     OCR1AH, Temp
	;out     OCR1AL, Tmp	
        ;ldi	Temp, 0
	;ldi     Tmp, 0
        ;out     OCR1BH, Temp
	;out     OCR1BL, Tmp
        ;ldi	Temp, 0
        ;ldi     Tmp, 0
	;out     ICR1H, Temp
	;out     ICR1L, Tmp

	;clr	Temp
	;sbr	Temp, (1<<COM1A1)+(0<<COM1A0)
	;sbr	Temp, (1<<COM1B1)+(0<<COM1B0)
	;sbr	Temp, (1<<WGM11)+(0<<WGM10)
	;out	TCCR1A, Temp
	;clr	Temp
	;sbr	Temp, (1<<WGM13)+(1<<WGM12)
	;sbr	Temp, (0<<CS12)+(0<<CS11)+(1<<CS10)
	;out	TCCR1B, Temp
	;in	Temp, TIMSK
	;sbr	Temp, (0<<TICIE1)+(0<<OCIE1A)+(0<<OCIE1B)+(0<<TOIE1)
	;out	TIMSK, Temp

    ; 2	
	;in	Temp, TIMSK	
	;sbr	Temp, (1<<OCIE2)
	;out	TIMSK, Temp
	;ldi	Temp, (1<<WGM21); 2    Auto Reload.
	;out	TCCR2, Temp
	


