
        rcall   WideRangeDelay          ;      ,        .

  ;   eeprom,  , ,      .
	ldi	Temp, eLastBright1_1
	rcall	EEPROM_Read		
	sts	meLastBright1_1, Temp	
	ldi	Temp, eLastBright1_2
	rcall	EEPROM_Read
	sts	meLastBright1_2, Temp	
	ldi	Temp, eLastBright2_1	
	rcall	EEPROM_Read		
	sts	meLastBright2_1, Temp	
	ldi	Temp, eLastBright2_2	
	rcall	EEPROM_Read
	sts	meLastBright2_2, Temp	
	ldi	Temp, eSystemBits		
	rcall	EEPROM_Read		
	mov	reSystemBits, Temp
        ldi	Temp, eUserBits1		
	rcall	EEPROM_Read		
	mov	reUserBits1, Temp
        ldi	Temp, eUserBits2
	rcall	EEPROM_Read		
	mov	reUserBits2, Temp


EEPROMtoSRAM    eTurnOnSpeedMode1Ch1, 1, 5, meTurnOnSpeedMode1Ch1 ;        1.
EEPROMtoSRAM    eTurnOnSpeedMode2Ch1, 1, 5, meTurnOnSpeedMode2Ch1 ;        1.
EEPROMtoSRAM    eTurnOffSpeedMode1Ch1, 1, 5, meTurnOffSpeedMode1Ch1 ;        1.
EEPROMtoSRAM    eTurnOffSpeedMode2Ch1, 1, 5, meTurnOffSpeedMode2Ch1 ;        1.
EEPROMtoSRAM    eTurnOnSpeedMode1Ch2, 1, 5, meTurnOnSpeedMode1Ch2 ;        2.
EEPROMtoSRAM    eTurnOnSpeedMode2Ch2, 1, 5, meTurnOnSpeedMode2Ch2 ;        2.
EEPROMtoSRAM    eTurnOffSpeedMode1Ch2, 1, 5, meTurnOffSpeedMode1Ch2 ;        2.
EEPROMtoSRAM    eTurnOffSpeedMode2Ch2, 1, 5, meTurnOffSpeedMode2Ch2 ;        2.

EEPROMtoSRAM    eOffTimeoutHoursCh1, 1, 24, meOffTimeoutHoursCh1 ; ,      1.
EEPROMtoSRAM    eOffTimeoutHoursCh2, 1, 24, meOffTimeoutHoursCh2 ; ,      2.
EEPROMtoSRAM    eOffTimeMode1Ch1, 1, 255, meOffTimeMode1Ch1 ;    1    .
EEPROMtoSRAM    eOffTimeMode1Ch2, 1, 255, meOffTimeMode1Ch2 ;    2    .
EEPROMtoSRAM    eBrightDecrPercentCh1, 10, 90, meBrightDecrPercentCh1 ;,       1    .
EEPROMtoSRAM    eBrightDecrPercentCh2, 10, 90, meBrightDecrPercentCh2 ;,       2    .
EEPROMtoSRAM    eOffTimeMode2Ch1, 1, 240, meOffTimeMode2Ch1 ;,     1          .
EEPROMtoSRAM    eOffTimeMode2Ch2, 1, 240, meOffTimeMode2Ch2 ;,     2          .

EEPROMtoSRAM    eOwnersAtHomeBright, cMinBrightOAH, 255, meOwnersAtHomeBright ;            .
EEPROMtoSRAM    eOwnersAtHomeOnPeriod, 1, cMaxDurationOAH, meOwnersAtHomeOnPeriod ;       .
EEPROMtoSRAM    eOwnersAtHomeOffPeriod, 1, cMaxDurationOAH, meOwnersAtHomeOffPeriod ;       .


        ldi     Temp, eBrightChangeSpeedCh1;    1    .
        rcall	EEPROM_Read
        cpi     Temp, 1
        brsh    PC+2
        ldi     Temp, 1
        cpi     Temp, 6
        brlo    PC+2
        ldi     Temp, 5
        mov     reBrightChangeSpeedCh1, Temp

        ldi     Temp, eBrightChangeSpeedCh2;    2    .
        rcall	EEPROM_Read
        cpi     Temp, 1
        brsh    PC+2
        ldi     Temp, 1
        cpi     Temp, 6
        brlo    PC+2
        ldi     Temp, 5
        mov     reBrightChangeSpeedCh2, Temp

        ldi     Temp, eBrightnessMinCh1 ;   1.              
        rcall	EEPROM_Read             ;       ,    eBrightnessMin .
        sts     meBrightnessMinCh1, Temp;   eBrightnessMin        .
        ldi	ZH, HIGH(2*BrightnessTable)
        ldi	ZL, LOW(2*BrightnessTable)
        add	ZL, Temp
        brcc    PC+2
        inc     ZH
        lpm	Tmp, Z+                 ;        eBrightnessMin.
    NextMinCh1:
        lpm	Temp, Z+                ;    .
        cp      Temp, Tmp               ;  
        brne    MinBrightDeterminedCh1  ;  ,   .   meBrightnessMin        ,    eBrightnessMin .
        lds     Temp, meBrightnessMinCh1;     ,
        inc     Temp                    ;   ,
        sts     meBrightnessMinCh1, Temp; ,
        rjmp    NextMinCh1              ;  .
    MinBrightDeterminedCh1:

        ldi     Temp, eBrightnessMaxCh1 ;   1.   ,
        rcall	EEPROM_Read             ;..      
        sts     meBrightnessMaxCh1, Temp;  cADCSamplesCount.

        ldi     Temp, eMinBrightDelayCh1;     1.
        rcall	EEPROM_Read             ;..       ,
        inc     Temp                    ; .
        sts     meMinBrightDelayCh1, Temp
        sts     mBrightMinCounterCh1, Temp

        ldi     Temp, eMaxBrightDelayCh1;     1.
        rcall	EEPROM_Read
        inc     Temp
        sts     meMaxBrightDelayCh1, Temp
        sts     mBrightMaxCounterCh1, Temp

        ldi     Temp, eBrightnessMinCh2 ;   2.
        rcall	EEPROM_Read
        sts     meBrightnessMinCh2, Temp
        ldi	ZH, HIGH(2*BrightnessTable)
        ldi	ZL, LOW(2*BrightnessTable)
        add	ZL, Temp
        brcc    PC+2
        inc     ZH
        lpm	Tmp, Z+
    NextMinCh2:
        lpm	Temp, Z+
        cp      Temp, Tmp
        brne    MinBrightDeterminedCh2
        lds     Temp, meBrightnessMinCh2
        inc     Temp
        sts     meBrightnessMinCh2, Temp
        rjmp    NextMinCh2
    MinBrightDeterminedCh2:

        ldi     Temp, eBrightnessMaxCh2 ;   2.
        rcall	EEPROM_Read
        sts     meBrightnessMaxCh2, Temp

        ldi     Temp, eMinBrightDelayCh2;     2.
        rcall	EEPROM_Read
        inc     Temp
        sts     meMinBrightDelayCh2, Temp
        sts     mBrightMinCounterCh2, Temp

        ldi     Temp, eMaxBrightDelayCh2;     2.
        rcall	EEPROM_Read
        inc     Temp
        sts     meMaxBrightDelayCh2, Temp
        sts     mBrightMaxCounterCh2, Temp

  ;    .
        rcall   ResetAutoOffTimerCh1    ;   
        rcall   ResetAutoOffTimerCh2    ; .

  ;   .
        in      rOutChannels, pMainOut

  ;   .
	sbr	rBit1, (1<<bBrightVectorCh1)+(1<<bBrightVectorCh2);          .

  ;  .
        in      Temp, ADCH              ;    .
        sts     mSeed, Temp             ;  (..  )   .

  ; //,        .
        sbrs    reSystemBits, ebOwnersAtHome;       (),
        rjmp    OwnersAtHomeNotActive
        sbrc    reSystemBits, ebPowerStateCh1;       ,
        rjmp    OwnersAtHomeWasInOnState
        ldi     Temp, 100              ;    
;ldi     Temp, 5;  ,     
        sts     mOwnersAtHomeSeconds, Temp;  
        ldi     Temp, 60                ;
        sts     mOwnersAtHomeMinutes, Temp;.
        lds     Temp, meOwnersAtHomeOffPeriod;      
        sbrs    reUserBits1, ebRandomOAH; ,
        rjmp    OwnersAtHomeWriteSharedCell;      ,  .
        rcall   RandomNumber8bit        ;      ,
        cpi     Temp, (cMaxDurationOAH + 1);    (cMaxDurationRndOAH + 1) (240 ),
        brlo    PC+2
        ldi     Temp, cMaxDurationOAH   ;   cMaxDurationRndOAH.
;ldi     Temp, 2;  ,            
  OwnersAtHomeWriteSharedCell:
        sts     mOwnersAtHomeSharedCell, Temp;      .
        rjmp    ExitTurnPrevState
  OwnersAtHomeWasInOnState:             ;        ,
        rcall   OwnersAtHomeTimerTrigger;             .
        rjmp    ExitTurnPrevState

OwnersAtHomeNotActive:
	sbrs	reUserBits1, ebTurnPrevStateCh1;   
	rjmp	TurnPrevStateCh2        ; 
	sbrs	reSystemBits, ebPowerStateCh1;   
	rjmp	TurnPrevStateCh2        ;  ,
	sbr	rBit1, (1<<bIsChannel1On)+(1<<bSoftTurnCh1);  
	clr	rBrightnessCh1	        ;   .
TurnPrevStateCh2:
	sbrs	reUserBits1, ebTurnPrevStateCh2
	rjmp	ExitTurnPrevState
	sbrs	reSystemBits, ebPowerStateCh2
	rjmp	ExitTurnPrevState
	sbr	rBit1, (1<<bIsChannel2On)+(1<<bSoftTurnCh2)
	clr	rBrightnessCh2
ExitTurnPrevState:

   ;      ,      .
        ;clr     Temp
        ;sbr     Temp, (1<<INTF1)+(1<<INTF0)+(1<<INTF2)
        ;out     GIFR, Temp      ; .
        ;in      Temp, SPSR      ; 
        ;in      Temp, SPDR      ; SPI.
        ;in      Temp, UDR       ;  USART,
        ;sbi     UCSRA, TXC      ; UDRE (USART Data Register Empty) -       .
        ;sbi     ADCSRA, ADIF    ; - .
        ;        EECR, EEWE      ; EEPROM Ready   -    eeprom  .
        ;sbi     ACSR, ACI       ; .
        ;in      Temp, TWCR      ;
        ;sbr     Temp, 1<<TWINT  ; 
        ;out     TWCR, Temp      ;TWI (I2C).
        ;        SPMCR, SPMEN    ;  Store Program Memory  , ..  SPM  .
        ;sbr     Temp, (1<<OCF2)+(1<<TOV2)+(1<<ICF1)+(1<<OCF1A)+(1<<OCF1B)+(1<<TOV1)+(1<<OCF0)+(1<<TOV0);     .
        ;out     TIFR, Temp       ;            .

        ;sei                      ;  .




